<id>
global_mods.mod
</id>

<version>
2.11 SP1.3beta4
</version>

<mod info>
Stand alone Global Moderator mod for those that don't want to install the Add More Membergroups Mod.

Creates a new user status: Global Moderator.

When a user's status is set to Global Moderator, the user has the same powers as any moderator, but on every board in your YaBB. The user's name will not show up on the moderator list, however. The user's status title can be customized in the admin center in the Edit Member Groups section just as you would customize normal admin and moderator names.

Global moderators may also edit the news, and the censored words list in the basic Global Moderator panel.

The admin may turn off this feature in the admin center.

You don't need this mod if you have installed the 'add more membergroups' mod.

New features in this version: More admin control over extended global moderator capabilities. You can allow GMod's to see hidden email addresses, edit the forum template, allow them to ban, allow them to edit boards and categories, allow them to perform the minor board maintenance tasks, and allow them to edit selected parts of someone's profile.

Notes on profile editing features:
Gmods *cannot* change the following items: Username, Display Name, password, email address, and Hide Email from public checkbox. The Global Moderator also cannot make someone a Global Moderator or an Admin, nor can they edit the membergroup of another Global Moderator or an Admin. Global Moderators cannot delete members from the Profile view. Global Moderators also cannot edit any items that are added to the profile by other mods unless the mod physically adds it to GlobalModerators.pl

Before installing this mod:

- Uninstall any previous versions of the Global Moderators mod.
- Change english.lng to the name of your language file

After installing this mod:
- Upload english.lng to the YaBB directory in ASCII mode
- Upload modified source files to the Sources directory in ASCII mode
- Upload GlobalModerators.pl to your Sources directory in ASCII mode
- Upload the file stargmod.gif into your YaBBImages directory (binary mode)
- Log in to your board and Edit your Member Groups. If you had added a member group to your board, you may find that this member group is now the Global Moderator group. Change as applicable. *Important: Click the Save Button even if you don't have to make any changes*
- Visit the Forum Settings and Preferences menu and select whether or not you want a GMod to have the GMod admin menu and whether or not you want GMod's to have added priviliges.
- Change a member's status to Global Moderator the same way you would change any member's membergroup status.

History:
v2.11beta4
- Moved Global Moderator Edit Profile functions to GlobalModerators.pl to reduce the chance of mod incompatability with existing mods and any future mods. This makes fixes made by beta3 moot.
v2.11beta3 (not released)
- Repaired bug caused by this mod on forums that email new passwords if email address is changed
- Made compatible with Extended Profiles mod - apply a 2 step mod file that modifies ExtendedProfile.pl
v2.11beta2
- Included admin selectable option to allow Global Moderators to selectively edit profiles.
v2.11beta1
- Updated to install on SP1.1/SP1.2/SP1.3/SP1.3.1 boards.
- Got rid of the patches for announcement boards and close thread mods - if patches are needed, I'll add them in.
- Fixed problem the original mod had with the redirection back to the GMod menu.
- Reordered mod steps to make it easier on manual installers. Mod steps now flow top down throughout the Source files.
- Hidden email addy display to GMods is now admin settable in Forum Preferences and Settings (defaults to don't show).
- Fixed version check image link in Global Moderator''s center.
- Added Edit template to the list of things GMod's have the capability to do - admin selectable.
- Added Modify Cats and Boards accessible (admin selectable)
- Added IPBan to list of items that are admin selectable
- Added the minor board maintenance items to the GMod menu (admin selectable)
- Made patch file for YaMS 4.0x compatibility.
v2.1:
- Security Bug fixed (hidden mail addy displayed in memberlist)
v2.0:
- SP1 compatible
- Global Moderators now can see hidden mail addresses
- more actions in "Global Moderators - Center"
- List Global Moderators in Admin and GM - Center (Sonic)
- IP is shown for the GM, because GM can ban members (dOCdaS)
v1.1: Major bug fixed where moderators lost powers when groupname was changed and profile was edited.
</mod info>

<author>
Seawolf (v2.11), previous versions: DaveB, Bjoern.
</author>

<homepage>
http://www.webappeal.com
</homepage>

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
$txt{'gmod1'} = "Admin";
$txt{'gmod2'} = "Global Moderator";
$txt{'gmod3'} = "Show Global Moderators the \"Global Moderators - Center\"?";
$txt{'gmod4'} = "Global Moderators";
$txt{'gmod5'} = "YaBB Global Moderators Center";
$txt{'gmod6'} = "This is your '$txt{'gmod5'}'. You can ban Members, edit the News and show at some statistics.<BR><BR>We thank you for using <a href=\"http://yabb.xnull.com\" target=\"_blank\">YaBB</a>!";
$txt{'gmod7'} = "Allow $txt{'gmod4'} to see hidden email addresses?";
$txt{'gmod8'} = "Allow $txt{'gmod4'} to edit the forum template?";
$txt{'gmod9'} = "Allow $txt{'gmod4'} to edit Boards and Categories?";
$txt{'gmod10'} = "Allow $txt{'gmod4'} to ban members?";
$txt{'gmod11'} = "Allow $txt{'gmod4'} to do basic forum maintenance?";
$txt{'gmod12'} = "Allow $txt{'gmod4'} to edit user profiles (high security items not editable)?";

</add before>

<search for>
	$img{'memberlist'} = qq~<font size="1" class="imgmenu">$txt{'331'}</font>~;
</search for>

<add after>
	$img{'moderate'} = qq~<font size="1" class="imgmenu">$txt{'gmod1'}</font>~;
</add after>

<search for>
	$img{'memberlist'} = qq~<img src="$imagesdir/guest.gif" alt="$txt{'331'}" border="0"> <font size="1" class="imgmenu">$txt{'331'}</font>~;
</search for>

<add after>
	$img{'moderate'} = qq~<img src="$imagesdir/admin.gif" alt="$txt{'gmod1'}" border="0"> <font size="1" class="imgmenu">$txt{'gmod1'}</font>~;
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
sub FullStats {
	&is_admin;
</search for>

<replace>
sub FullStats {
	&is_admin_or_gmod;
</replace>

<search for>
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
</search for>

<replace>
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' || $moderators{$username} || ! $curcataccess;
</replace>

<search for>
	&LoadAdmins;
</search for>

<add after>
	&LoadGMods;
</add after>

<search for>
    <font size="2"><B>$txt{'684'}:</B></font> <font size="1">$administrators</font><BR><BR>
</search for>

<add after>
    <font size="2"><B>$txt{'gmod4'}:</B></font> <font size="1">$gmoderators</font><BR><BR>
</add after>

<search for>
sub ShowClickLog {
	&is_admin;
</search for>

<replace>
sub ShowClickLog {
	&is_admin_or_gmod;
</replace>

<search for>
sub AdminBoardRecount {
	&is_admin;
</search for>

<replace>
sub AdminBoardRecount {
	&is_admin_or_gmod;
</replace>

<search for>
sub RebuildMemList { 
	&is_admin; 
</search for>

<replace>
sub RebuildMemList { 
	&is_admin_or_gmod;
</replace>

<search for>
sub ipban {
	&is_admin;
</search for>

<replace>
sub ipban {
	&is_admin_or_gmod;
</replace>

<search for>
sub ipban2 {
	&is_admin;
</search for>

<replace>
sub ipban2 {
	&is_admin_or_gmod;
</replace>

<search for>
	print FILE "$FORM{'ban_memname'}";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
</search for>

<replace>
	print FILE "$FORM{'ban_memname'}";
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
</replace>

<search for>
sub ver_detail {
	&is_admin;
</search for>

<replace>
sub ver_detail {
	&is_admin_or_gmod;
</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub EditNews {
	&is_admin;
</search for>

<replace>
sub EditNews {
	&is_admin_or_gmod;
</replace>

<search for>
sub EditNews2 {
	&is_admin;
</search for>

<replace>
sub EditNews2 {
	&is_admin_or_gmod;
</replace>

<search for>
	print FILE "$FORM{'news'}";
	fclose(FILE);
	$yySetLocation = qq~$cgi\;action=admin~;
</search for>

<replace>
	print FILE "$FORM{'news'}";
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
</replace>

<search for>
	for( $i = 7; $i < @lines; ++$i ) {
</search for>

<replace>
	for( $i = 8; $i < @lines; ++$i ) {
</replace>

<search for>
	$yymain .= qq~
<table border="0" width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
</search for>

<add before>
	if (!$lines[7]) { $lines[7] = "Global Moderator"; }
</add before>

<search for>
        <td><input type=text name="admin" size=30 value="$lines[0]"></td>
</search for>

<add after>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'gmod2'}:</b></font></td>
        <td><input type=text name="global" size=30 value="$lines[7]"></td>
</add after>

<search for>
	print FILE "$FORM{'god'}\n";
</search for>

<add after>
	print FILE "$FORM{'global'}\n";
</add after>

<search for>
sub SetCensor {
	&is_admin;
</search for>

<replace>
sub SetCensor {
	&is_admin_or_gmod;
</replace>

<search for>
sub SetCensor2 {
	&is_admin;
</search for>

<replace>
sub SetCensor2 {
	&is_admin_or_gmod;
</replace>

<search for>
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
</search for>

<replace>
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
</replace>

<search for>
sub ModifyTemplate {
	&is_admin;
</search for>

<replace>
sub ModifyTemplate {
	&is_admin_or_gmod;
</replace>

<search for>
sub ModifyTemplate2 {
	&is_admin;
</search for>

<replace>
sub ModifyTemplate2 {
	&is_admin_or_gmod;
</replace>

<search for>
	print FILE $FORM{'template'};
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
</search for>

<replace>
	print FILE $FORM{'template'};
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
</replace>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($gmodchecked, $gmodshowemail, $gmodedittemplate, $gmodeditcat, $gmodban, $gmodmaint, $gmodeditprof);
</add after>

<search for>
	if ($enable_ubbc) { $ubbcchecked = ' checked'; }
</search for>

<add before>
	if ($allow_mod) { $gmodchecked = ' checked'; }
	if ($showgmod_email) {$gmodshowemail = ' checked'; }
	if ($allowgmod_edittemp) {$gmodedittemplate = ' checked'; }
	if ($allowgmod_editcat) {$gmodeditcat = ' checked'; }
	if ($allowgmod_ban) {$gmodban = ' checked'; }
	if ($allowgmod_maint) {$gmodmaint = ' checked'; }
	if ($allowgmod_editprof) {$gmodeditprof = ' checked'; }
</add before>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_guestposting" $gpchecked></td>
</search for>

<add after>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_mod" value="1"$gmodchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod7'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgmod_email" value="1"$gmodshowemail></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod8'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_edittemp" value="1"$gmodedittemplate></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod9'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_editcat" value="1"$gmodeditcat></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_ban" value="1"$gmodban></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_maint" value="1"$gmodmaint></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_editprof" value="1"$gmodeditprof></td>
</add after>

<search for>
	$timeout = $FORM{'timeout'} || 5;
</search for>

<add before>
	$allow_mod = $FORM{'allow_mod'} || 0;
	$showgmod_email = $FORM{'showgmod_email'} || 0;
	$allowgmod_edittemp = $FORM{'allowgmod_edittemp'} || 0;
	$allowgmod_editcat = $FORM{'allowgmod_editcat'} || 0;
	$allowgmod_ban = $FORM{'allowgmod_ban'} || 0;
	$allowgmod_maint = $FORM{'allowgmod_maint'} || 0;
	$allowgmod_editprof = $FORM{'allowgmod_editprof'} || 0;
</add before>

<search for>
########## Feature Settings ##########

</search for>

<add after>
\$allow_mod = $allow_mod;  				# Set to 1 to activate a "Global Moderators - Center"
\$showgmod_email = $showgmod_email;  		# Set to 1 to let Global Moderators see hidden email addresses
\$allowgmod_edittemp = $allowgmod_edittemp;  		# Set to 1 to let Global Moderators edit the forum template
\$allowgmod_editcat = $allowgmod_editcat;  		# Set to 1 to let Global Moderators edit the forum boards and categories
\$allowgmod_ban = $allowgmod_ban;  			# Set to 1 to let Global Moderators edit the ban list
\$allowgmod_maint = $allowgmod_maint;  		# Set to 1 to let Global Moderators perform routine forum maintenance
\$allowgmod_editprof = $allowgmod_editprof;		# Set to 1 to let Global Moderators edit non-security related profile items
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
</search for>

<replace>
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { $openmemgr{$curcat} = 1; }
</replace>

<search for>
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
</search for>

<replace>
		if(!$curcataccess || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { $openmemgr = 1; }
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		$mip = $settings[7] eq 'Administrator' ? $mip : "$txt{'511'}";
</search for>

<replace>
		$mip = $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ? $mip : "$txt{'511'}";
</replace>

<search for>
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
</search for>

<replace>
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || ($settings[7] eq 'Global Moderator' && $showgmod_email) || $allow_hide_email ne 1) {
</replace>

<search for>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
</search for>

<replace>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' || $username eq $musername) {
</replace>

<search for>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator') {
</search for>

<replace>
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
sub LoadLogCount {
	&is_admin;
</search for>

<replace>
sub LoadLogCount {
	&is_admin_or_gmod;
</replace>

<search for>
sub LoadAdmins {
	&is_admin;
</search for>

<replace>
sub LoadAdmins {
	&is_admin_or_gmod;
</replace>

<search for>
		if (!$user_ip && $settings[7] eq 'Administrator') { $yyim .= qq~<br><b>$txt{'773'}</b>~; }
</search for>

<replace>
		if (!$user_ip && ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator')) { $yyim .= qq~<br><b>$txt{'773'}</b>~; }
</replace>

<search for>
	if($userprofile{$user}->[7] eq 'Administrator') {
		$memberstar{$user} = qq~<img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*"><img src="$imagesdir/staradmin.gif" border="0" alt="*">~;
		$memberinfo{$user} = "<B>$membergroups[0]</B>";
	}
</search for>

<add after>
	if( $userprofile{$user}->[7] eq 'Global Moderator' ) {
		$memberstar{$user} = qq~<img src="$imagesdir/stargmod.gif" border="0" alt="*"><img src="$imagesdir/stargmod.gif" border="0" alt="*"><img src="$imagesdir/stargmod.gif" border="0" alt="*"><img src="$imagesdir/stargmod.gif" border="0" alt="*"><img src="$imagesdir/stargmod.gif" border="0" alt="*">~;
		$memberinfo{$user} = "<B>$membergroups[7]</B>";
	}
</add after>

<search for>
	if($userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator') { $groupinfo{$user} = "$userprofile{$user}->[7]<BR>"; }
</search for>

<replace>
	if( ($userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator') || ($userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Global Moderator') ) { $groupinfo{$user} = "$userprofile{$user}->[7]<BR>"; }
</replace>

<search for>
	if($userprofile{$user}->[7] ne 'Administrator') {
</search for>

<replace>
	if($userprofile{$user}->[7] ne 'Administrator' && $userprofile{$user}->[7] ne 'Global Moderator') {
</replace>

<search for>
sub LoadLogCount {
</search for>

<add before>
sub LoadGMods {
	&is_admin_or_gmod;
	my (@members, $curentry);

	$gmoderators = '';
	fopen(FILE, "$memberdir/memberlist.txt");
	@members = <FILE>;
	fclose(FILE);
	foreach $curentry (@members) {
		chomp $curentry;
		&LoadUser($curentry);
		if($userprofile{$curentry}->[7] eq 'Global Moderator') {
			$gmoderators .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$curentry}">$userprofile{$curentry}->[1]</a><font size="1">,</font> \n~;
		}
	}
	$gmoderators =~ s~<font size="1">,</font> \n\Z~~;
}
</add before>

<edit file>
Sources/LockThread.pl
</edit file>

<search for>
	if((exists $moderators{$username}) || $settings[7] eq "Administrator") {
</search for>

<replace>
	if((exists $moderators{$username}) || $settings[7] eq "Administrator"  || $settings[7] eq "Global Moderator") {
</replace>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
sub ManageBoards {
	&is_admin;
</search for>

<replace>
sub ManageBoards {
	&is_admin_or_gmod;
</replace>

<search for>
sub ReorderBoards {
	&is_admin;
</search for>

<replace>
sub ReorderBoards {
	&is_admin_or_gmod;
</replace>

<search for>
sub ReorderBoards2 {
	&is_admin;
</search for>

<replace>
sub ReorderBoards2 {
	&is_admin_or_gmod;
</replace>

<search for>
sub ModifyBoard {
	&is_admin;
</search for>

<replace>
sub ModifyBoard {
	&is_admin_or_gmod;
</replace>

<search for>
sub CreateBoard {
	&is_admin;
</search for>

<replace>
sub CreateBoard {
	&is_admin_or_gmod;
</replace>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
sub ManageCats {
	&is_admin;
</search for>

<replace>
sub ManageCats {
	&is_admin_or_gmod;
</replace>

<search for>
sub ReorderCats {
	&is_admin;
</search for>

<replace>
sub ReorderCats {
	&is_admin_or_gmod;
</replace>

<search for>
sub CreateCat {
	&is_admin;
</search for>

<replace>
sub CreateCat {
	&is_admin_or_gmod;
</replace>

<search for>
sub ModifyCat {
	&is_admin;
</search for>

<replace>
sub ModifyCat {
	&is_admin_or_gmod;
</replace>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
				~; } else { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
				~; }
</search for>

<replace>
				if ($showgmod_email) {
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
				~; } else { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
				~; }
				} else {
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] eq 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
				~; } else { $yymain .= qq~
					<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
				~; }
				}
</replace>

<search for>
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
			~; } else { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
			~; }
</search for>

<replace>
			if ($showgmod_email) {
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
			~; } else { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
			~; }
			} else {
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] eq 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
			~; } else { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
			~; }
			}
</replace>

<search for>
		if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_hide_email eq 1) { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
		~; } else { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
		~; }
</search for>

<replace>
		if ($showgmod_email) {
		if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
		~; } else { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
		~; }
		} else {
		if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] eq 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
		~; } else { $yymain .= qq~
			<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
		~; }
		}
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' ) {
</search for>

<replace>
	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator' ) {
</replace>

<search for>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator') {
</search for>

<replace>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
</replace>

<search for>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator') {
</search for>

<replace>
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
</replace>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") { &fatal_error("$txt{'134'}"); }
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'134'}"); }
</replace>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") { &fatal_error("$txt{'134'}"); }
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'134'}"); }
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	if($settings[7] eq 'Administrator') {
		$position='';
		foreach $curl (@lines) {
			if($curl ne $lines[1] && $curl ne $lines[2] && $curl ne $lines[3] && $curl ne $lines[4] && $curl ne $lines[5] && $curl ne $lines[6]) {
				if($curl ne $lines[0]) { $position= qq~$position<option>$curl~; }
				else { $position= qq~$position<option value="Administrator">$curl~; }
			}
		}
		if($memsettings[7] eq 'Administrator') { $tt = $lines[0]; }
		else { $tt = $memsettings[7]; }
</search for>

<replace>
	if($settings[7] eq 'Administrator') {
		$position='';
		foreach $curl (@lines) {
			if($curl ne $lines[1] && $curl ne $lines[2] && $curl ne $lines[3] && $curl ne $lines[4] && $curl ne $lines[5] && $curl ne $lines[6]) {
				if($curl ne $lines[0] && $curl ne $lines[7]) { $position= qq~$position<option>$curl~; }
				elsif($curl eq $lines[0]) { $position= qq~$position<option value="Administrator">$curl~; }
				elsif($curl eq $lines[7]) { $position= qq~$position<option value="Global Moderator">$curl~; }
			}
		}
		if($memsettings[7] eq 'Administrator') { $tt = $lines[0]; }
		elsif($memsettings[7] eq 'Global Moderator') { $tt = $lines[7]; }
		else { $tt = $memsettings[7]; }
</replace>

<search for>
	if ($memsettings[19] ne "checked" || $settings[7] eq "Administrator" || !$allow_hide_email) {
</search for>

<replace>
	if ($username ne $INFO{'username'} && ($settings[7] eq "Global Moderator" && $allowgmod_editprof)) {
		$modify = qq~&#171; <a href="$cgi;action=gmodeditprofile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
	if ($memsettings[19] ne "checked" || $settings[7] eq "Administrator" || ($settings[7] eq 'Global Moderator' && $showgmod_email ) || !$allow_hide_email) {
</replace>

<search for>
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
</search for>

<replace>
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
</replace>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
			if($settings[7] ne 'Administrator' && !exists $membergroups{$settings[7]}) { next; }
</search for>

<replace>
			if($settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator' && !exists $membergroups{$settings[7]}) { next; }
</replace>

<search for>
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
</search for>

<replace>
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
</replace>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator") {
</search for>

<replace>
	if((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") {
</replace>

<edit file>
Sources/Security.pl
</edit file>

<search for>
sub banning {
</search for>

<add before>
sub is_admin_or_gmod {
	if($settings[7] ne 'Administrator' && ($settings[7] ne 'Global Moderator' || $allow_mod != 1)) { &fatal_error($txt{'1'}); }
}
</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'modify',"ModifyMessage.pl&ModifyMessage",
</search for>

<add before>
'gmodeditprofile',"GlobalModerators.pl&GModEditProfile",
'gmodeditprofile2',"GlobalModerators.pl&GModEditProfile2",
'moderate',"GlobalModerators.pl&Moderate",
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add after>
	if($settings[7] eq 'Global Moderator' && $allow_mod == 1) { $yymenu .= qq~$menusep<a href="$cgi;action=moderate">$img{'moderate'}</a>~; }
</add after>

<search for>
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
</search for>

<replace>
		$yyAccessCat{$curcat} = $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' || $moderators{$username} || ! $curcataccess;
</replace>

<search for>
		$yyAccessCat{$yyCatBoard{$curboard}} = $settings[7] eq 'Administrator' || $moderators{$username} || ! $curcataccess;
</search for>

<replace>
		$yyAccessCat{$yyCatBoard{$curboard}} = $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' || $moderators{$username} || ! $curcataccess;
</replace>